// Hitachi44780 LCD fonksiyonlar
// Ayhan Olgun, 2005

// 2*40 iin
// Shift Register dzeni


int lcd_ekran[85];

void lcd_baytgonder(char bayt,int1 rs) {
   char i;
   for(i=0;i<8;i++) {
      LCD_VERI=(((bayt<<i)&128)==128);
		LCD_SAAT=0;LCD_SAAT=1;
		}
	LCD_SAAT=rs;
	LCD_CEVIR=1;
 //  delay_us(2/DENE);
   LCD_CEVIR=0;
   		   }


void bufsil(char * a, int x) {
   int i;
   for(i=0;i<x;i++) a[i]=' ';
   }


void lcd_ekransil(void) {
	lcd_baytgonder(1,0);
   delay_ms(2);
   bufsil(lcd_ekran,80);
   	}

void lcd_basadon(void) {
	lcd_baytgonder(2,0);
   delay_ms(2);
		}

void lcd_imlec(char a) {         // imlec a-kapat.
	lcd_baytgonder(12|a,0);    // ekran a-kapat kontrol de burda sabit.
  delay_us(50);
		}

void lcd_kur(void) {
	lcd_baytgonder(0b00111011,0);    // bit 0-1: nemsiz.
     delay_us(200);              // bit 2: =0:font 5x7 =1:font 5x10 piksel
                               // bit 3: =0:tek satr ilem
   	                         // bit 4: =1:sekiz bit veriyolu
                                // bit 5-6-7: =1-0-0 bu komut iin sabit
lcd_baytgonder(0b00000110,0);
delay_us(200);
lcd_baytgonder(0b00010000,0);
delay_us(200);


}
void adr_cgram(char a) {
	a=a&0x3f;
	lcd_baytgonder(64|a,0);
//  delay_us(50/DENE);
			}

void adr_ddram(char a) {
   if(a>39) a+=24;                    // ikinci satrn hemen birinci satrn sonundan balad varsaylacak.
   lcd_baytgonder(128|a,0);
 //  delay_us(50/DENE);
		}

void  lcd_yaz(char a) {
	lcd_baytgonder(a,1);
//   delay_us(100/DENE);
		}


void lcd_bas(char * a,int ekranx,int bufx,int s) {
char i;
   adr_ddram(ekranx);
//   delay_us(100/DENE);
   for(i=bufx;i<s;i++) lcd_yaz(a[i]);
			}


void lcd_yenile(int x, int s) {
   int i;
   adr_ddram(x);
//   delay_us(100/DENE);
   s+=x;
   for(i=x; i<s; i++) lcd_yaz(lcd_ekran[i]);
   }

//       

void lcd_turkceharfler(void) {
   adr_cgram(8);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00010001);
   lcd_yaz(0b00010000);
   lcd_yaz(0b00010000);
   lcd_yaz(0b00010000);
   lcd_yaz(0b00010001);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00011000);

   lcd_yaz(0b00011111);
   lcd_yaz(0b00000000);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00010000);
   lcd_yaz(0b00010111);
   lcd_yaz(0b00010001);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00000000);

   lcd_yaz(0b00001111);
   lcd_yaz(0b00010000);
   lcd_yaz(0b00010000);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00000001);
   lcd_yaz(0b00000001);
   lcd_yaz(0b00011110);
   lcd_yaz(0b00001100);

   lcd_yaz(0b00000000);
   lcd_yaz(0b00000000);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00010000);
   lcd_yaz(0b00010000);
   lcd_yaz(0b00010001);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00011000);

   lcd_yaz(0b00011111);
   lcd_yaz(0b00000000);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00010001);
   lcd_yaz(0b00010001);
   lcd_yaz(0b00001111);
   lcd_yaz(0b00000001);
   lcd_yaz(0b00011110);

   lcd_yaz(0b00000000);
   lcd_yaz(0b00000000);
   lcd_yaz(0b00001100);
   lcd_yaz(0b00000100);
   lcd_yaz(0b00000100);
   lcd_yaz(0b00000100);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00000000);

   lcd_yaz(0b00000000);
   lcd_yaz(0b00000000);
   lcd_yaz(0b00001111);
   lcd_yaz(0b00010000);
   lcd_yaz(0b00001110);
   lcd_yaz(0b00000001);
   lcd_yaz(0b00011110);
   lcd_yaz(0b00001100);

}

int asc2bsc(int a) {

  switch(a) {
   case '':
      return 1;
   case '':
      return 2;
   case '':
      return 3;
   case '':
      return 4;
   case '':
      return 5;
   case '':
      return 6;
   case '':
      return 7;
   case '':
      return 0xf5;
   case '':
      return 0xf5;
   case '':
      return 0xEF;
   case '':
      return 0xef;
   case '\\':
      return '/';
   case '':
      return 'i';
   case 'W':
      return '_';
   default:
      return a;
               }
                 }


void lcd_tyenile(int x, int s) {
   int i;
   adr_ddram(x);
//   delay_us(100/DENE);
   s+=x;
   for(i=x; i<s; i++) lcd_yaz(asc2bsc(lcd_ekran[i]));
   }
