// Ev Kumanda Sistemi, Ayhan Olgun, 2006

#include"E:\pic-c\devices\18f458.h"
#device *=16
#use delay (clock=40000000)
#include"string.h"

#priority ext,timer1,timer0,timer3
#zero_ram

// Avermedia tv kart kumandas iin, 32 bit kodu u ekilde indirgedim; alglanan orjinal kod u olsun: 0x12345678,
// bu 0x1567 haline indirgenecek. Bu ekilde en azndan bu kumanda iin herhangi bir akma olmayacak.

#DEFINE AC 0xBFF0
#DEFINE TELETEXT 0xB3FC
#DEFINE CD 0xBBF4
#DEFINE TV 0xB7F8
#DEFINE VIDEO 0xBDF2      
#DEFINE UC 0xB1FE
#DEFINE IKI 0xB9F6
#DEFINE BIR 0xB5FA
#DEFINE AUDIO 0xBEF1
#DEFINE ALTI 0xB2FD
#DEFINE BES 0xBAF5
#DEFINE DORT 0xB6F9
#DEFINE FULLSCREEN 0xBCF3
#DEFINE DOKUZ 0xB0FF
#DEFINE SEKIZ 0xB8F7
#DEFINE YEDI 0xB4FB
#DEFINE PREVIEW 0xBF70
#DEFINE LOOP 0xB37C
#DEFINE DISPLAY 0xBB74
#DEFINE SIFIR 0xB778
#DEFINE MUTE 0xBD72
#DEFINE CAPTURE 0xB17E
#DEFINE FREEZE 0xB976
#DEFINE AUTOSCAN 0xB57A
#DEFINE PLAY 0xBE71
#DEFINE STOP 0xB27D
#DEFINE PAUSE 0xBA75
#DEFINE RECORD 0xB679
#DEFINE SARI 0xBC73
#DEFINE SES_ARTI 0xB07F
#DEFINE SES_EKSI 0xB877
#DEFINE BORDO 0xB47B
#DEFINE MAVI 0x3FF0
#DEFINE KANAL_ARTI 0x33FC
#DEFINE KANAL_EKSI 0x3BF4
#DEFINE YESIL 0x37F8


#byte tmr0=0x0fd6
#byte t0con=0x0fd5
#byte t1con=0x0fcd
#byte t2con=0x0fca
#byte t3con=0x0fb1
#byte tmr1h=0x0fcf
#byte tmr1l=0x0fce
#byte tmr2=0x0fcc
#byte tmr3l=0x0fb2
#byte tmr3h=0x0fb3
#bit ipen=0x0fd0.7


#byte trisa=0x0f92
#byte trisb=0x0f93
#byte trisc=0x0f94
#byte trisd=0x0f95
#byte trise=0x0f96

#byte porta=0x0f80
#byte portb=0x0f81
#byte portc=0x0f82
#byte portd=0x0f83
#byte porte=0x0f84
#byte adcon1=0x0fc1

#bit lcd_veri=0x0f83.2
#bit lcd_saat=0x0f83.1
#bit lcd_cevir=0x0f83.0
#bit led=0x0f83.3
#bit tus=0x0f83.4
#bit sebeke=0x0f81.1

#include"LCD.C"

#bit kontrol0=0x0f81.7
#bit kontrol1=0x0f81.6
#bit kontrol2=0x0f81.5
#bit kontrol3=0x0f81.4
#bit kontrol4=0x0f81.3
#bit kontrol5=0x0f83.7
#bit kontrol6=0x0f83.6
#bit kontrol7=0x0f83.5
#bit kontrol8=0x0f80.5
#bit kontrol9=0x0f80.4

#bit kes0kenar=0x0ff1.6
#bit kes1kenar=0x0ff1.5

int1 algila=0;
int ir_bitir=10;
int32 ir_komut=0;
int1 ir_komutvar=0;
int32 saniyedoldur=0;
int saniye=0;
int dakika=0;
int saat=0;
int16 temp16;
int t0frekansbol=0;
int t1frekansbol=0;
int t3temp=0;
int ayarlandi=0;
int lcddemo=1;

#bit tmr0if=0x0ff2.2
#bit tmr1if=0x0f9e.0
#bit tmr2if=0x0f9e.1
#bit tmr3if=0x0fa1.1
#bit int0if=0x0ff2.1
#bit int1if=0x0ff0.0
#byte pr2=0x0fcb

int tmr0a=0;
int ir_asama=0;
#include"vfd.C"
int birkacatlat;

int ir_komutvar2=0;

int sesacik=1;
int klik=0;
int sesper;
#bit sesrolesi=0x0f84.2

int alarm=0;
int alarmper, alarmper_t, alarmkacklik;
int saniyeisareti=0;
//***********************************************************************************************

#byte tosu=0x0fff
#byte tosh=0x0ffe
#byte tosl=0x0ffd
#byte stkptr=0x0ffc
#byte status=0x0fd8
#byte bsr=0x0fe0
#byte tmr0=0x0fd6
#byte t0con=0x0fd5
#byte rcon=0x0fd0
int p_sira=0;
int p_toshbuf[2];
int p_toslbuf[2];
int p_bankbuf[2];
int p_tempbank;
int p_bekle[2];
int p_stkptr[2];

int tur[10]={0,0,1,2,1,0,0,0,0,0};
char isim[10][15]={"FLORESAN      ","PRIZWROLESI   ","TUNGSTEN      ","FIRIN         ","FENER         ","KONTROL-5WWWWW","KONTROL-6WWWWW","KONTROL-7WWWWW","KONTROL-8WWWWW","KONTROL-9WWWWW"};
int zam1[10];
int zam2[10];
int guc[10];
int alarmdurumu[10];
int eskiguc[10];
int yeniguc[10];
int kd[10];

int mod=0;
int mod1=0;
int mod2=0;
int mod3=0;

void kportyaz(int x,int y) {
   switch(x) {
   case 0: kontrol0=y; break;
   case 1: kontrol1=y; break;
   case 2: kontrol2=y; break;
   case 3: kontrol3=y; break;
   case 4: kontrol4=y; break;
   case 5: kontrol5=y; break;
   case 6: kontrol6=y; break;
   case 7: kontrol7=y; break;
   case 8: kontrol8=y; break;
   case 9: kontrol9=y; break;
      }
        }

void kportyaz2(int x,int y) {
   switch(x) {
   case 0: kontrol0=y; break;
   case 1: kontrol1=y; break;
   case 2: kontrol2=y; break;
   case 3: kontrol3=y; break;
   case 4: kontrol4=y; break;
   case 5: kontrol5=y; break;
   case 6: kontrol6=y; break;
   case 7: kontrol7=y; break;
   case 8: kontrol8=y; break;
   case 9: kontrol9=y; break;
      }
        }

int kportoku(int x) {
   switch(x) {
   case 0: return kontrol0;
   case 1: return kontrol1;
   case 2: return kontrol2;
   case 3: return kontrol3;
   case 4: return kontrol4;
   case 5: return kontrol5;
   case 6: return kontrol6;
   case 7: return kontrol7;
   case 8: return kontrol8;
   case 9: return kontrol9;
      }
        }


void p_beklet(int a) {

   p_tempbank=bsr;

   p_bekle[p_sira]=a;

   p_toshbuf[p_sira]=tosh;
   p_toslbuf[p_sira]=tosl;
   p_bankbuf[p_sira]=p_tempbank;
   p_stkptr[p_sira]=stkptr;

   do{
   p_sira^=1;
   } while(p_bekle[p_sira]);

disable_interrupts(GLOBAL);
   stkptr=p_stkptr[p_sira];
   p_tempbank=p_bankbuf[p_sira];
   tosu=0;
   tosh=p_toshbuf[p_sira];
   tosl=p_toslbuf[p_sira];
   bsr=p_tempbank;
enable_interrupts(GLOBAL);
   return;
    }

//**************************************************************

void alarmbaslat(kacdefa, periyot) {
   alarmper=periyot;
   alarmkacklik=kacdefa;
   alarm=1;
  }

int sebekevar;

void ext1f() {
   kes1kenar^=1;
   sebekevar=2;
   tmr2=0;
   enable_interrupts(int_timer2);
       }

#int_ext1
ext1() {
   ext1f();
    }

#int_ext
ext0() {


switch(ir_asama) {
   case 0:
      tmr0=0;
      tmr0a=0;
      ir_asama=1;
      birkacatlat=5;
      break;
   case 1:
      if(tmr0a==2) {ir_asama=2; tmr0=0; tmr0a=0; ir_komut=0;}
         else ir_asama=0;
      break;
   case 2:
      if(tmr0a==1) {ir_asama=3;ir_komutvar=1; ir_komutvar2=1; klik=1;}
      if(!tmr0a) {ir_komut=(ir_komut<<1)|(tmr0<67);}
      tmr0=0; tmr0a=0;
      break;
   case 3:
      if((!birkacatlat)&&(tmr0a==1)) {ir_komutvar=1; ir_komutvar2=1;}
      if(birkacatlat) birkacatlat--;
      tmr0=0; tmr0a=0;
      break;

         }
if(tmr3if) {tmr3if=0;saniyedoldur+=524288;}
  }


int16 kumandaoku(void) {
int16 temp0;
int16 temp1;
   if(ir_komutvar) {ir_komutvar=0;
                  temp0=ir_komut;
                  temp0>>=4;
                  temp1=(ir_komut>>16)&0xf000;
                  return temp1|temp0;
                    }

   else return 0;
                      }

int16 kumandaoku2(void) {
int16 temp0;
int16 temp1;
   if(ir_komutvar2) {ir_komutvar2=0;
                  temp0=ir_komut;
                  temp0>>=4;
                  temp1=(ir_komut>>16)&0xf000;
                  return temp1|temp0;
                    }

   else return 0;
                      }




#int_timer0
t0() {
   tmr0a++;
   if(tmr0a==15) ir_asama=0;
   if(tmr3if) {tmr3if=0;saniyedoldur+=524288;}
      }

int anim1=0;
int tmr1x=200;

#int_timer1
t1() {
   int temp;
   int i;

   if(!fsira) {
   if(t1frekansbol==4) {t1frekansbol=0;
                          anim1++;

                           switch(anim1)
                              {
                               case 0:
                                 f_cgram[0]=fj;
                                 f_cgram[1]=fa;
                                 f_cgram[2]=fd;
                                 f_cgram[3]=fi;
                                 f_cgram[4]=fb;
                                 break;
                               case 1:
                                 f_cgram[0]=fa;
                                 f_cgram[1]=fd;
                                 f_cgram[2]=fa;
                                 f_cgram[3]=fa;
                                 f_cgram[4]=fa;

                                 break;

                               case 2:
                                 f_cgram[0]=fd;
                                 f_cgram[1]=fa;
                                 f_cgram[2]=fj;
                                 f_cgram[3]=fh;
                                 f_cgram[4]=fc;

                                 break;

                               case 3:
                                 f_cgram[0]=fa;
                                 f_cgram[1]=fj;
                                 f_cgram[2]=fa;
                                 f_cgram[3]=fa;
                                 f_cgram[4]=fa;

                                 anim1=255;
                                 break;
                             }


                         }

      else t1frekansbol++;

               }


   f_bas();

   tmr1h=tmr1x;
   tmr1l=0;

   if(tmr3if) {tmr3if=0; saniyedoldur+=524288;}
   if(int1if) {int1if=0; ext1f();}

   }


#int_timer2
t2(){
int i;
static int j=9;
static int k=9;

   if(j) j--; else {j=9; if(k) k--; else k=9; if(sebekevar) disable_interrupts(int_timer2);}


   for(i=0;i<10;i++) {
      switch(tur[i]) {
         case 0:
         case 1:
            if(guc[i]) {if(guc[i]>=j) kportyaz2(i,1); else kportyaz2(i,0);} else kportyaz2(i,0); break;
         case 2:
            if(guc[i]) {if(guc[i]>=k) kportyaz2(i,1); else kportyaz2(i,0);} else kportyaz2(i,0); break;
            }
           }

   if(tmr3if) {tmr3if=0; saniyedoldur+=524288;}

}





//************************************************************************************************************
int sebekeizle=0;
int harfzmn=8;
#int_timer3
t3() {
int i=0;
int x=0;
   saniyedoldur+=524288;
   t3temp++;
   if(harfzmn) if(harfzmn<13) harfzmn--;
   if(saniyedoldur>10000000) {if(ayarlandi) saniye++;
     saniyedoldur-=10000000;
     if(saniye>59) {saniye=0; dakika++;
        if(sebekevar) {if(sebekeizle) sebekeizle--;} else sebekeizle=5;
        for(i=0; i<10; i++) {
         if(zam1[i]&128) {if(zam1[i]&127) zam1[i]--; else {eskiguc[i]=guc[i]; guc[i]=0; zam1[i]&=127; if(alarmdurumu[i]) alarmbaslat(10,15);}}
         if(zam2[i]&128) {if(zam2[i]&127) zam2[i]--; else {guc[i]=yeniguc[i]; zam2[i]&=127; if(alarmdurumu[i]) alarmbaslat(3,7);}}
                                  }

      if(dakika>59) {saat++; dakika=0;
      if(saat>23) {/*gun_arttir();*/ saat=0;}
                                             }

                                             }


                                     }

  if(p_bekle[0]) p_bekle[0]--;
         if(ir_komutvar) p_bekle[0]=0;
         if(p_bekle[1]) p_bekle[1]--;



if(sesacik) {
switch(klik) {
   case 1:
     sesrolesi=1;
      klik=2;
      sesper=3;
      break;
   case 2:
      sesper--;
      if(!sesper){sesrolesi=0; klik=0;}
   } }
else sesrolesi=0;


switch(alarm)
   {
      case 1:
         klik=1;
         alarm=2;
         alarmper_t=alarmper;
         if(alarmkacklik) alarmkacklik--; else alarm=0;
         break;
      case 2:
         if(!klik) alarm=3;
         break;
      case 3:
         alarmper_t--;
         if(!alarmper_t) alarm=1;
     }

if(sebekevar) sebekevar--; else enable_interrupts(int_timer2);

for(i=0; i<10; i++) {
if(!sebekevar) {
                if(kd[i]==1) guc[i]=0;
                if(kd[i]==2) {kd[i]=3; sebekeizle=5; eskiguc[i]=guc[i]; guc[i]=0;}
                 }
if(kd[i]==3) if(!sebekeizle) {guc[i]=eskiguc[i]; kd[i]=2;}
                  }



if(int1if) {int1if=0; ext1f();}

}


//****************************************************************************************************************


void zamanla(int t) {
      static int temp;
      static int* x;
      x=zam1+t;
      f_foto();
      temp16=0;
      tekrar_zamanla:
      sprintf(fbuf,"%u DAKIKA    ",*x&127);
      if((*x)&128) {
      fbuf[12]='d';
      fbuf[13]='e';}
         else {fbuf[12]='-'; fbuf[13]='-';}

         if(alarmdurumu[t]) fbuf[10]='c'; else fbuf[10]='W';

         if(temp16==SES_ARTI)  {(*x)&=127;(*x)++;if(*x==128) *x=0;}

         if(temp16==SES_EKSI) {(*x)&=127; (*x)--; if(*x==255) *x=60;}


         if(temp16==SIFIR) {*x=0;}
         if(temp16==STOP) {if(*x&128) *x&=127; else {f_foto(); return;}}
         if(temp16==PLAY) if(*x){if(*x&128) {f_foto();return;} else *x|=128;}
         if(temp16==AUDIO) alarmdurumu[t]^=1;

         temp=t; p_beklet(2); t=temp;
         temp16=kumandaoku();

      goto tekrar_zamanla;
      }

void zamanla2(int t) {
      static int* x;
      static int* y;
      x=zam2+t;
      y=yeniguc+t;
      f_foto();
      temp16=0;
      tekrar_zamanla:
      sprintf(fbuf,"%u DAKIKA -%u   ",*x&127,*y);
      if((*x)&128) {
      fbuf[12]='d';
      fbuf[13]='e';}
         else {fbuf[12]='-'; fbuf[13]='-';}

         if(temp16==SES_ARTI)  {(*x)&=127;(*x)++;if(*x==128) *x=0;}

         if(temp16==SES_EKSI) {(*x)&=127; (*x)--; if(*x==255) *x=60;}

         if(temp16==KANAL_ARTI) if(*y<9) (*y)++;
         if(temp16==KANAL_EKSI) if(*y) (*y)--;

         if(temp16==SIFIR) {*x=0;}
         if(temp16==STOP) {if(*x&128) *x&=127; else {f_foto();return;}}
         if(temp16==PLAY) if(*x){if(*x&128) {f_foto();return;} else *x|=128;}
         p_beklet(2);
         temp16=kumandaoku();

      goto tekrar_zamanla;
      }


int harfsecsifirla=0;

const char harfler[10][5]={" 0",".-_1","ABC2","DEF3","GHI4","JKL5","MNO6","PRS7","TUV8","YZ9"};

char harfsec(int a) {
   static int b=0;
   static int onceki=0;
   if(onceki==a) b++;
   if(!harfler[a][b]) b=0;
   if(harfsecsifirla) {harfsecsifirla=0; b=0;}
   onceki=a;
   harfzmn=12;                      // 13'te ve 0'da takl kalr, dier saylarda 52 ms admlarla geri sayar.
   return harfler[a][b];
               }


void harfgir(char* x) {

   static int16 tx;
   static int harfsirasi;
   static int harf;
   for(harfsirasi=0;harfsirasi<14;harfsirasi++) fbuf[harfsirasi]=x[harfsirasi];
   harfsirasi=0;
   harfzmn=13;
   *fbuf|=128;

   tekrar_harf:
   temp16=kumandaoku();

   harf=0;
   if(temp16==BIR) harf=harfsec(1);
   if(temp16==IKI) harf=harfsec(2);
   if(temp16==UC) harf=harfsec(3);
   if(temp16==DORT) harf=harfsec(4);
   if(temp16==BES) harf=harfsec(5);
   if(temp16==ALTI) harf=harfsec(6);
   if(temp16==YEDI) harf=harfsec(7);
   if(temp16==SEKIZ) harf=harfsec(8);
   if(temp16==DOKUZ) harf=harfsec(9);
   if(temp16==SIFIR) harf=harfsec(0);

   if(!harfzmn) {harfzmn=13; harfsecsifirla=1; temp16=SES_ARTI;}
   if(temp16==SES_ARTI) if(harfsirasi<12) {fbuf[harfsirasi]&=127; fbuf[++harfsirasi]|=128;}
   if(temp16==SES_EKSI) if(harfsirasi) {fbuf[harfsirasi]&=127; fbuf[--harfsirasi]|=128;}
   if(temp16==TV) {fbuf[harfsirasi]&=127;
                   for(harfsirasi=0;harfsirasi<12;harfsirasi++) x[harfsirasi]=fbuf[harfsirasi];
                   x[harfsirasi]=0;
                   temp16=0;
                   return;
                   }

   if(harf) fbuf[harfsirasi]=harf|128;

   tx=x; p_beklet(2); x=tx;
   goto tekrar_harf;
   }

void turdegistir(void) {
     tekrar_td:
     temp16=kumandaoku();
     if(temp16==SES_ARTI) tur[mod]=(tur[mod]+1)%3;
     if(temp16==TV) {if(!tur[mod]) if(guc[mod]) guc[mod]=9; temp16=0; return;}
     switch(tur[mod]) {
       case 0: strcpy(fbuf,"ROLE          "); break;
       case 1: strcpy(fbuf,"DALGA KIRAN   "); break;
       case 2: strcpy(fbuf,"PAKET         "); break;
                     }
     p_beklet(2); goto tekrar_td;
     }

void kapanmamodudegis(void) {
     tekrar_kd:
     temp16=kumandaoku();
     if(temp16==SES_ARTI) kd[mod]=(kd[mod]+1)%3;
     if(temp16==TV) {TEMP16=0; return;}
     switch(kd[mod]) {
       case 0: strcpy(fbuf,"ETKISIZ       "); break;
       case 1: strcpy(fbuf,"KAPAT         "); break;
       case 2:
       case 3: strcpy(fbuf,"KAPAT-BEKLE-AC"); break;
                     }
     p_beklet(2); goto tekrar_kd;
     }


//****************************************************************


int lcdanim0f() {
static int lcdanim0=0;
static int lcdanim0t=0;
lcdanim0t?lcdanim0--:lcdanim0++;
       if(lcdanim0==5) {lcdanim0t^=1;lcdanim0=3;}
       if(lcdanim0==255) {lcdanim0t^=1;lcdanim0=1;}
       return (1<<lcdanim0);

       }


//************************************************************
int vfdilk=0;
int i=0;
int j=0;
int k=0;
int sonkontrol=0;
char const bilgi[]="                        EV KUMANDA SSTEM - Ayhan Olgun, 2006, Denizli - Kullanlan dosya: " __FILE__ " - Gnn zl sz: Sen! Bugn Antrak iin n'aptin?! :) Antrak'a sevgi ve sayglarmzla..                 ";

int vfdsaatmod=0;
//2.prog deikenleri:
int _mod;
int _i=0;
int _j=0;
int _k=0;
int _t0=0;
int _t1=3;
int16 _temp16=0;
char const turismi[3][11]={"Rle","Dalgakran","Paket"};
//*************************************************************************************
//***********************************************************************************
//******************************************************************************

main() {
adcon1=7;
trisa=0b11001111;
trisb=0b00000111;
trisc=0;
trisd=0b00010000;
trise=0b00000011;
ipen=0;
pr2=150;
for(i=0;i<10;i++) kportyaz(i,0);
delay_ms(500);

lcd_kur(); delay_ms(100);
lcd_ekransil(); delay_ms(10);
lcd_imlec(0); delay_ms(100);
lcd_kur(); delay_ms(100);

p_toslbuf[1]=label_address(prog1);
p_toshbuf[1]=(label_address(prog1)>>8);
p_stkptr[1]=20;
p_bekle[1]=0;





t0con=0b11000111;          //8 bit preskaler 1:256   birim bekleme 6.5 mS
t1con=0b10000001;          //16 bit preskaler yok
t2con=0b00011110;          //8 bit preskaler 16, postskaler 4
t3con=0b10110001;          //16 bit preskaler 1:8 (52.4288 ms)
enable_interrupts(int_timer0);
enable_interrupts(int_timer1);
enable_interrupts(int_ext);
enable_interrupts(int_ext1);
enable_interrupts(int_timer3);

kes0kenar=0; // den kenar tetik
kes1kenar=0;
tmr0=0;
enable_interrupts(global);

alarmbaslat(2,6);

if(stkptr||(rcon!=0x9c)) {
sprintf(lcd_ekran,"stkptr= %X rcon= %X     ",stkptr,rcon);
lcd_yenile(0,24);
sprintf(fbuf,"S= %X   R= %X ",stkptr,rcon);
while(!(ir_komutvar||tus));
                             }

lcd_turkceharfler();

strcpy(lcd_ekran,"LCD EKRAN HAZIR...       ");
lcd_yenile(0,24);

strcpy(fbuf,"88888888888888");
delay_ms(1000);

strcpy(fbuf,"AOL (C) 2005  ");

delay_ms(1000);
lcd_ekransil();
//****************************************************************************************************************
//********************************
//****
//*

mod=255;

prog0:

   temp16=kumandaoku();

   if(mod==255) {

    if(!vfdilk) {
    sprintf(fbuf,"%2d-%02d",saat,dakika); //(role1zaman&128)?'a':(role1?'X':'W'),(role2zaman&128)?'b':(role2?'X':'W'));
    if(!ayarlandi) for(k=1;k<5;k++) fbuf[k]|=128;
    for(k=0; k<8; k++) {
    if(tur[k]) fbuf[6+k]=(guc[k]+'0')|(zam1[k]&128);
      else fbuf[6+k]=(zam1[k]&128)?'a':(guc[k]?'X':'W');
            }
             }

    if(vfdilk==1) {
      sprintf(fbuf,"%2d-%02d-%02d ",saat,dakika,saniye);
          for(k=0; k<5; k++) {
            if(tur[k]) fbuf[9+k]=(guc[k]+'0')|(zam1[k]&128);
            else fbuf[9+k]=(zam1[k]&128)?'a':(guc[k]?'X':'W');
            }
                  }

    if(vfdilk==2) {
          for(k=0; k<10; k++) {
            fbuf[0]=' ';fbuf[1]=' ';fbuf[12]=' ';fbuf[13]=' ';
            if(tur[k]) fbuf[2+k]=(guc[k]+'0')|(zam1[k]&128);
            else fbuf[2+k]=(zam1[k]&128)?'a':(guc[k]?'X':'W');
            }}


     switch (temp16) {
    case BIR: f_foto(); mod=1; break;
    case IKI: f_foto(); mod=2; break;
    case UC: f_foto(); mod=3; break;
    case DORT: f_foto(); mod=4; break;
    case BES: f_foto(); mod=5; break;
    case ALTI: f_foto(); mod=6; break;
    case YEDI: f_foto(); mod=7; break;
    case SEKIZ: f_foto(); mod=8; break;
    case DOKUZ: f_foto(); mod=9; break;
    case SIFIR: f_foto(); mod=0; break;
    case VIDEO: f_foto(); mod=254;break;        
    case CAPTURE: f_foto(); mod=253; break;     
    case TELETEXT: vfdilk=(vfdilk+1)%3;
                        }
     temp16=0;


            }


   if(mod<10) {
       if(lcddemo==2) if(_mod-mod) lcd_ekransil(); _mod=mod;
       strcpy(fbuf,isim[mod]);
       fbuf[13]='0'+guc[mod];

       if(!tur[mod]) {
         if(temp16==AC) {if(guc[mod]) guc[mod]=0; else guc[mod]=9;}
         if(temp16==BIR) zamanla(mod);
                  }
       else
                  {
         if(temp16==AC) {if(guc[mod]) {eskiguc[mod]=guc[mod]; guc[mod]=0;} else guc[mod]=eskiguc[mod];}
         if(temp16==BIR) zamanla(mod);
         if(temp16==IKI) zamanla2(mod);
         if(temp16==SES_ARTI) if(guc[mod]<9) guc[mod]++;
         if(temp16==SES_EKSI) if(guc[mod]) guc[mod]--;
                   }
         if(temp16==YEDI) kapanmamodudegis();
         if(temp16==SEKIZ) harfgir(isim[mod]);
         if(temp16==DOKUZ) turdegistir();
                   }


   if(mod==254) {     //saat ayar VIDEO
      if(temp16==IKI) saat=(saat+1)%24;
      if(temp16==BIR) {if(saat) saat--; else saat=23;}
      if(temp16==BES) dakika=(dakika+1)%60;
      if(temp16==DORT) {if(dakika) dakika--; else dakika=59;}
      if(temp16==YEDI) {saniye=0; saniyedoldur=0;}
      if(temp16==TV) {mod=0;ayarlandi=1;}
     sprintf(fbuf,"eab%02db%02db%02dcbd",saat,dakika,saniye);
                    }


   if(mod==253||(!tus)) {
            sprintf(fbuf,"%lX-%lX  ",ir_komut,temp16);
            mod=253;
            if(temp16==TV) {mod=255; delay_ms(1000);}
                  }


if(temp16==TV) {if(mod<10) sonkontrol=mod; mod=255; f_foto();}


p_beklet(5);

goto prog0;




//**************************************************************************************
//*******************************

prog1:

     _temp16=kumandaoku2();
     if(_temp16==YESIL) {
        if(guc[sonkontrol]) {eskiguc[sonkontrol]=guc[sonkontrol]; guc[sonkontrol]=0;} else guc[sonkontrol]=eskiguc[sonkontrol];
              }

    if(_temp16==CD) {adr_cgram(0); for(_i=0;_i<8;_i++) lcd_yaz(0); lcd_ekransil();lcddemo++;}

   if(_temp16==LOOP) {
         if(tur[sonkontrol]) if(guc[sonkontrol]<9) guc[sonkontrol]++;
         }


   if(_temp16==DISPLAY) {
        if(tur[sonkontrol]) if(guc[sonkontrol]) guc[sonkontrol]--;
         }



  if(lcddemo==1) {
 _t0^=1;
     if(_t0) {
      _j++;
     if(bilgi[_j+18]) for(_i=0; _i<19; _i++) {lcd_ekran[_i]=bilgi[_i+_j]; lcd_ekran[39-_i]=bilgi[_i+_j];}
      else _j=0;

      lcd_ekran[19]=0;
      lcd_ekran[20]=0;
      lcd_ekran[0]=0;
      lcd_ekran[39]=0;

 sprintf(lcd_ekran+56,"%2u:%02u:%02u",saat,dakika,saniye);
      lcd_yenile(56,8);

              }

      adr_cgram(0);
      lcdanim0f();
      for(_i=0; _i<8; _i++) lcd_yaz(lcdanim0f());

      lcd_tyenile(0,40);

                       }

   if(lcddemo==2) {
      sprintf(lcd_ekran,"%d-%s (%s) G=%d/9   ",_mod,isim[_mod],turismi[tur[_mod]],guc[_mod]);
      sprintf(lcd_ekran+40,"1.Gerisaym: %u-%C 2.Gerisaym: %u-%C  ",zam1[_mod]&127,(zam1[_mod]&128)?'':'D',zam2[_mod]&127,(zam2[_mod]&128)?'':'D');
      lcd_tyenile(0,80);
      }


   if(lcddemo==3) {
      f_kapali=1;
      lcd_ekransil();
      lcddemo=33;  }

    if(lcddemo==33) lcd_bas(fbuf,66,0,14);
    if(lcddemo==34) {lcddemo=4; f_kapali=0;}


if(lcddemo==4) {
      sprintf(lcd_ekran,"PORTA: %X * PORTB: %X * PORTC: %X *     PORTD: %X * PORTE: %X Tmr1x: %u ", porta, portb, portc, portd, porte,tmr1x);
     if(_temp16==KANAL_ARTI) tmr1x++;
     if(_temp16==KANAL_EKSI) tmr1x--;
      lcd_yenile(0,80);

               }



   if(lcddemo==5) lcddemo=1;

p_beklet(2);
goto prog1;

}




















































// Ev Kumanda Sistemi, Ayhan Olgun, 2006
